unit mod2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WABD_Objects,
  WABD_Setup,
  WABD_Handlers,
  WABD_Attributes;

type


  TDataModule2 = class(TDataModule)
    WABD_Session1: TWABD_Session;
    WABD_Setup1: TWABD_Setup;
    wabdHTMLFile1: TWABD_HTMLFile;
    wabdHTMLFile2: TWABD_HTMLFile;
    wabdHTMLFileAuth: TWABD_HTMLFile;
    wabdHtmlJson: TWABD_HTML;
    procedure WABD_Session1Exception(Sender: TObject; E: Exception;
      var Handled: Boolean);
    procedure DataModuleCreate(Sender: TObject);
    procedure WABD_Session1FirstLogon(RemoteHost: string);
    procedure WABD_Session1BeforeProcessRequest(Session: TWABD_Session);
  private
    { Private declarations }

  public
    { Public declarations }
    [UrlAttribute('/', '*', utStartSession)]
    procedure handleStart(request: TWABD_HRequest;
          response: TWABD_HResponse);
    [UrlAttribute('/save', '*', utInternal)]
    procedure handleSave(request: TWABD_HRequest;
          response: TWABD_HResponse);
    [UrlAttribute('/due', '*', utInternal)]
    procedure handleDue(request: TWABD_HRequest;
          response: TWABD_HResponse);
    [UrlAttribute('/ba*', '*', utInternal)]
    procedure handleReturn(request: TWABD_HRequest;
          response: TWABD_HResponse);
    [UrlAttribute('/sauth', '*', utInternal)]
    procedure handleAuth(request: TWABD_HRequest;
          response: TWABD_HResponse);
  end;

var
  DataModule2: TDataModule2;

implementation

{$R *.DFM}


procedure TDataModule2.DataModuleCreate(Sender: TObject);
begin

  WABD_Session1.urlHandlers:=Self;
end;

procedure TDataModule2.WABD_Session1BeforeProcessRequest(
  Session: TWABD_Session);
begin
    if WABD_Setup1.LocalFilePath='' then
      WABD_Setup1.LocalFilePath:=WABD_Session1.SessionMgr.ModulePath;
end;

procedure TDataModule2.WABD_Session1Exception(Sender: TObject; E: Exception;
  var Handled: Boolean);
var
  i: Integer;
begin
    for I := 0 to WABD_Session1.Request.Headers.Count - 1 do
    begin
        WABD_Session1.SessionMgr.Admin.Log('HEADER-'+WABD_Session1.Request.Headers.Strings[i]);
    end;

    WABD_Session1.SessionMgr.Admin.Log('EXCEPTION: '+ IntToStr(WABD_Session1.Request.RequestType) + ' '+ e.Message);

    Handled := True;
end;

procedure TDataModule2.WABD_Session1FirstLogon(RemoteHost: string);
begin
  WABD_Session1.SessionMgr.Admin.Log('>>>> First Logon');
end;


procedure TDataModule2.handleSave(request: TWABD_HRequest; response: TWABD_HResponse);
var
  nn: string;
  ck: TWABD_HCookie;
begin
    WABD_Session1.SessionMgr.Admin.Log('Hnd +chiamata OK');
    wabdHtmlJson.Variables.Add('statusCode=success');
    Response.Response.Add(wabdHtmlJson.Object_To_HTML);
    Response.ContentType:='application/json';
    nn:= 'myck';
    ck:=request.Cookies.GetCookieByName(nn);
    if (Assigned(ck)) then
    begin
        WABD_Session1.SessionMgr.Admin.Log('COOKIE: '+nn+' -> '+WABD_Session1.SessionMgr.Decrypt(ck.Value));
    end;
end;

procedure TDataModule2.handleDue(request: TWABD_HRequest; response: TWABD_HResponse);
begin
  response.Response.Add(wabdHTMLFile2.Object_To_HTML);
end;

procedure TDataModule2.handleReturn(request: TWABD_HRequest; response: TWABD_HResponse);
begin
  response.Response.Add(wabdHTMLFile1.Object_To_HTML);
end;

procedure TDataModule2.handleAuth(request: TWABD_HRequest; response: TWABD_HResponse);
begin
    WABD_Session1.SessionMgr.Admin.Log('Auth received name: '+request.query.values['name']);
    Response.Response.Add( '{r: success}');
    Response.ContentType:='application/json';
end;


procedure TDataModule2.handleStart(request: TWABD_HRequest; response: TWABD_HResponse);
begin
  response.Response.Add(wabdHTMLFileAuth.Object_To_HTML);
  response.Cookies.Add('ck1', WABD_Session1.SessionMgr.Encrypt('gds1960'));
end;

end.
