unit modSesmgr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WABD_Objects,
  WABD_Request,
  WABD_Response,
  WABD_Admin,
  WABD_Admin_Component,
  WABD_Common;

type
  TmoduleSesmgr = class(TDataModule)
    WABD_SessionMgr1: TWABD_SessionMgr;
    WABD_Admin1: TWABD_Admin;
    wabdHtmlFull: TWABD_HTML;
    wabdHtmlExpired: TWABD_HTML;
    procedure WABD_SessionMgr1DestroySession(Session: TWABD_Session);
    procedure WABD_SessionMgr1CreateAdminSession(var NewSession: TWABD_Session;
      Request: TWABD_CustomRequest; var validated: Boolean);
    procedure WABD_SessionMgr1CreateSession(var NewSession: TWABD_Session;
      Request: TWABD_CustomRequest; var validated: Boolean);
    procedure WABD_SessionMgr1Authenticate(RemoteHost, UserName,
      Password: string; var Authenticated: Boolean);
    procedure WABD_SessionMgr1SystemXHttpResponse(Request: TWABD_CustomRequest;
      sysResponse: TWABD_SysResponse; var systemResp: string);
    procedure WABD_SessionMgr1InvalidSession(Sender: TObject;
      var CreateNew: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  moduleSesmgr: TmoduleSesmgr;

implementation

uses mod2;

{$R *.DFM}

// Called if choosed Http Basic Authentication
procedure TmoduleSesmgr.WABD_SessionMgr1Authenticate(RemoteHost, UserName,
  Password: string; var Authenticated: Boolean);
begin
    Authenticated:=True;
end;

procedure TmoduleSesmgr.WABD_SessionMgr1CreateAdminSession(
  var NewSession: TWABD_Session; Request: TWABD_CustomRequest;
  var validated: Boolean);
begin
    with TWABDAdmin.Create(nil) do
        NewSession := WABDAdminSession ;
    validated:=True;
end;

procedure TmoduleSesmgr.WABD_SessionMgr1CreateSession(
  var NewSession: TWABD_Session; Request: TWABD_CustomRequest;
  var validated: Boolean);
var
  dm: TDataModule2;
begin
  dm:= TDataModule2.Create(nil);
  NewSession := dm.WABD_Session1 ;
  validated:=dm.WABD_Session1.ValidateUrlForNewSession(Request.RequestPath);
  if (not (validated))
      then
  begin
    WABD_SessionMgr1.Response.Location:=Request.ScriptName+'/';
  end;

end;

procedure TmoduleSesmgr.WABD_SessionMgr1DestroySession(
  Session: TWABD_Session);
begin
     Session.Owner.Free;
end;

procedure TmoduleSesmgr.WABD_SessionMgr1InvalidSession(Sender: TObject;
  var CreateNew: Boolean);
begin
  CreateNew:=True;
end;

procedure TmoduleSesmgr.WABD_SessionMgr1SystemXHttpResponse(
  Request: TWABD_CustomRequest; sysResponse: TWABD_SysResponse;
  var systemResp: string);
begin
  systemResp:='{"status":"error", "serverdata": {"messhtml": "<h1>FORBIDDEN</h1>"}, '
      +'"message": '+inttostr(ord(sysResponse)) + '}';
end;

initialization
 moduleSesmgr := TmoduleSesmgr.Create(nil);

end.
