unit WABD_Common;

interface

const
   WABD_VERSION_STR  = 'kbmWABD v. 4.00';
   WABD_VERSION      = 4.00;


   CR                     = #13#10;
   WABD_SES_ID_STR_FORMAT = '%d:%s:%s';
   WABD_SES_ID_STR_SEPARATOR = ':';
   WABD_CODED_NAME_PREFIX = '_W_';
   WABD_NAME_PREFIX       = '_WABD_';




   WABD_SEMAPHORE_TIMEOUT=20*60*60*1000;      // 20 minutes should be more than enough.

   // Internal sequence names.
   WABD_IMAGE_SEQUENCE = 'WABD_IMAGE_SEQUENCE';

   // Default group names for stats.
   WABD_STATGRP_RESPONSE       = 'Response';
   WABD_STATGRP_NETRESPONSE    = 'Net response';
   WABD_STATGRP_SENDSIZE       = 'Sendsize';
   WABD_STATGRP_RECVSIZE       = 'Recvsize';



   WABD_STATUS_OK         = 200;
   WABD_STATUS_REDIRECT   = 302;
   WABD_STATUS_AUTH       = 401;
   WABD_STATUS_ERROR      = 403;

   WABD_REQUESTTYPE_UNKNOWN =0;
   WABD_REQUESTTYPE_HTML    =1;
   // Ajax request
   WABD_REQUESTTYPE_XMLHTTP =30;



   WABD_BrowserUnknown    =0;
   WABD_BrowserIExplorer  =1;
   WABD_BrowserIExplorer11=2;
   WABD_BrowserMozilla    =3;
   WABD_BrowserChrome     =4;
   WABD_BrowserEdge       =5;

   WABD_IExplorer_Name    = 'MSIE';
   WABD_IExplorer11_Name  = 'TRIDENT';
   WABD_Mozilla_Name      = 'FIREFOX';
   WABD_Chrome_Name       = 'CHROME';
   WABD_Edge_Name         = 'EDGE';

   WABD_Browser : array [WABD_BrowserUnknown..WABD_BrowserEdge] of string =
     ('Other',
      'MS Internet Explorer',
      'MS Internet Explorer 11',
      'Mozilla Firefox',
      'Google Chrome',
      'Microsoft Edge'
     );

   EXPIRATION_TIME_MIN = 2;


type
   TWABD_Logging                  = (logNothing,logLevel1,logLevel2,logAll);
   TWABD_Storage                  = (storeNone,storeIniFile,storeJsonFile);
   TWABD_Produce                  = (prodAuto,prodHTML);
   TWABD_BodyLayout               = (layoutAuto,layoutTABLE, layoutCSS, layoutNONE);
   TWABD_VariableType            = (wabdVarTypeStandard, wabdVarTypeOld, wabdVarTypeMustache);

   TWABD_SysResponse             = (srNone, srExpired, srNoHandler, srNoSes, srFullSes,
        srFullUser, srHttp403 );
   TWABD_AuthType                = (atBasic, atCustom);
const
   WABD_SysResponseStrings: array [TWABD_SysResponse] of string = (
      '',
      'Session expired',
      'No handler for Url',
      'No session accepted',
      'Max sessions number exceeded',
      'Max sessions per user exceeded',
      'Server error'
   );

   WABD_VariableTypeStrings: array [TWABD_VariableType, 0..1] of string = (
      ('<%','%>'),                     // wabdTagStandard
      ('[!','!]'),                     // wabdTagOld
      ('{{','}}')                      // wabdTagMustache
   );


     WABD_VAR_SERVERAPP              = '$W_SERVERAPP';
     WABD_VAR_SERVERNAME             = '$W_SERVERNAME';
     WABD_VAR_SESSIONID              = '$W_SESSIONID';
     WABD_VAR_USERNAME               = '$W_USERNAME';
     WABD_VAR_INFO                   = '$W_INFO';
     WABD_VAR_HITCOUNT               = '$W_HITCOUNT';
     WABD_VAR_VERSION                = '$W_VERSION';
     WABD_VAR_SITENAME               = '$W_SITENAME';
     WABD_VAR_SITEID                 = '$W_SITEID';
     WABD_VAR_WEBADMIN               = '$W_WEBADMIN';
     WABD_VAR_MODULENAME             = '$W_MODULENAME';
     WABD_VAR_BASEURL                = '$W_BASEURL';
     WABD_VAR_BODYNAME               = '$W_BODYNAME';


var
//gds crypt
// hidden/cookie field names, they can be coded to obfuscate the HTML pages
   WABD_SES_ID_STR            : string  = '_WABD_SESSIONID';    // field to hold session information
   WABD_CLIENTPROCESSTIME_STR : string  = '_WABD_CLIENTPROCESSTIME'; // CLPRT:time float field resend by client of how long time from request to answer.

implementation

end.
