unit WABD_HTMLPreprocess;

interface
uses Classes, SysUtils, Windows, Forms, Graphics, Controls, StdCtrls, ExtCtrls,
      WABD_Common, superobject;

 function Process_Variables(HTML:string;FVariables:TStrings; VariableType:TWABD_VariableType):string;

implementation
 uses
   mustapas, WABD_Utils;



var
  renderEng: TRenderEngine;



function Process_Variables(HTML:string; FVariables:TStrings; VariableType:TWABD_VariableType):string;
var
   StartTag,EndTag:string;
   i:integer;

   jsonOb: ISuperObject;
   tempOb: ISuperObject;
begin
   if FVariables.Count<=0 then
   begin
        Result:=HTML;
        exit;
   end;


   jsonOb:=tsuperobject.ParseString('{}', True);
   for i:=0 to FVariables.Count-1 do
   begin
      tempOb:=TSuperObject.ParseString(PWideChar(FVariables.ValueFromIndex[i]), true) ;
      if (tempOb<>nil) and ((tempOb.DataType = stArray) or (tempOb.DataType = stObject)) then
          jsonOb.O[FVariables.Names[i]]:=tempOb
      else
          jsonOb.S[FVariables.Names[i]]:=FVariables.ValueFromIndex[i] ;
   end;

   StartTag:=WABD_VariableTypeStrings[VariableType][0];
   EndTag  :=WABD_VariableTypeStrings[VariableType][1];

   renderEng.setDelimiterTags(StartTag, EndTag);
   renderEng.renderTemplate(HTML, jsonOb, Result);
end;

initialization
begin
  renderEng:=TRenderEngine.Create;
end;

finalization
begin
  renderEng.Free;
end;
end.
