unit WABD_Utils;

{$include kbmWABD.inc}

interface

uses classes,sysutils,Graphics,Windows,Math;

   function MonthName(DateTime:TDateTime):string;
   function DayName(DateTime:TDateTime):string;
   procedure SplitSessionID(str:string;var Session,FormName:string);
   function FormatPath(Path:string):string;
   function ExtractModuleDir(): string;
   function FormatLocalPath(Path:string):string;

implementation
uses WABD_Common, System.StrUtils;

const
   MonthNames: array[1..12] of string = (
    'Jan', 'Feb', 'Mar', 'Apr',
    'May', 'Jun', 'Jul', 'Aug',
    'Sep', 'Oct', 'Nov', 'Dec');
   DayNames:  array[1..7] of string = (
    'Sun', 'Mon', 'Tue', 'Wed',
    'Thu', 'Fri', 'Sat');

// ************************************************************************
// Utility functions
// ************************************************************************

function MonthName(DateTime:TDateTime):string;
var
   Year,Month,Day:Word;
begin
     DecodeDate(DateTime,Year,Month,Day);
     Result:=MonthNames[Month];
end;

function DayName(DateTime:TDateTime):string;
begin
     Result:=DayNames[DayOfWeek(DateTime)];
end;

procedure SplitSessionID(str:string;var Session,FormName:string);
var
   i1, i2:integer;
begin
     i1:=pos(WABD_SES_ID_STR_SEPARATOR,str);
     i2:=posex(WABD_SES_ID_STR_SEPARATOR,str, i1+1);
     Session:=copy(str,1,i1-1);
     FormName:=copy(str,i1+1, i2-i1-1);
end;
function FormatPath(Path:string):string;
begin
     Result:=Path;
     if Copy(Result, Length(Result), 1)<>'/' then Result:=Result+'/';
end;

// Extract the DLL path, not the executable (server) path
function ExtractModuleDir(): string;
begin
    result  := ExtractFilePath(GetModuleName(HInstance));
    // IIS fix
    if LeftStr(result, 4) = '\\?\' then
        result := RightStr(result, Length(result)-4);
    if Copy(result,length(result),1)<>'\' then result:=result+'\';
end;

function FormatLocalPath(Path:string):string;
var
   s:string;
begin
     Result:=Path;
     if (Result<>'') and (Copy(Result, Length(Result), 1)<>'\') then Result:=Result+'\';
     if ExtractFileDrive(Result)='' then
     begin
// Extract the DLL path, not the executable (server) path
          s := ExtractModuleDir;
          if Result<>'' then
             Result:=s+Result
          else
            Result:=s;
     end;
end;


end.
