// var "moduleName" must be defined before loading this script
var config = {
   tabs: {
        name: 'tabs',
        active: 'tab1',
        tabs: [
            { id: 'tab1', caption: 'Sessions' },
            { id: 'tab2', caption: 'General setup' },
            { id: 'tab3', caption: 'Statistics' }
        ]
   },  
   form1: {
        name  : 'form1',
        url   : 'sendtx',
        fields: [
            { field: 'eInfo', type: 'text' }
        ],
        actions: {
            sendtx: function () {
                this.save();
            }
        }
   },
   form2: {
        name  : 'form2',
        url   : 'killa',
        fields: [  ],
        actions: {
            killa: function () {
                this.save();
            }
        }
   },
   formSetup: {
        name  : 'formSetup',
		url   : {
			get  :'setup',
			save : 'setups'
		},
//	formHtml: conHtmlForm1,
//	recid: '1',
        fields: [
            { field: 'eAdminUser', type: 'text', required: true },
            { field: 'eAdminPassword', type: 'text', required: true },
            { field: 'eAdminPasswordRetype', type: 'text' },
            { field: 'chbGarbageCollection', type: 'checkbox' },
            { field: 'eGarbageInterval', type: 'int', required: true,  options: {min: 10, max: 9999} },
            { field: 'chbGatherStatistics', type: 'checkbox' },
            { field: 'chbNetworkStats', type: 'checkbox' },
            { field: 'eTimeout', type: 'int', required: true,  options: {min: 1, max: 10000} },
            { field: 'eAdminText', type: 'text', required: true },
	    { field: 'eMaxIdenticalUser', type: 'int', required: true, options: {min: -1, max: 10} },
	    { field: 'eMaxSessions', type: 'int', required: true, options: {min: -1, max: 1000} },
	    { field: 'eRouteWhen', type: 'list', required: true, 
                          options: {items: [{'id':0, 'text': 'Don\'t route'}, 
					   {'id': 1, 'text': 'When full'}, 
					   {'id': 2, 'text': 'Always'} ],
			  selected: {id: 0 }  } },
	    { field: 'eRouteHow', type: 'list', required: true,
                          options: {items: [{'id': 0, 'text': 'Random'}, 
		                            {'id': 1, 'text': 'Round robin'}],
                          selected: {'id':0}   }   },
	    { field: 'mRouteSites', type: 'textarea' }
        ],
        actions: {
            save1: function () {
                this.save();
            },
            save2: function () {
                this.save();
            }
        }
   },
   grid: {
        name: 'sessionGrid',
	url: {
            get    : 'sess',
            remove : 'sessdel'
            },
        show: {
            toolbar          : true,
	    toolbarInput     : false,
            toolbarDelete    : true,
	    footer           : true,
	    selectColumn     : true
        },
        multiSelect  : false,
        columns: [
            { field: 'sessionid', caption: 'SessionID', size: '100px' },
            { field: 'user', caption: 'User', size: '100px', sortable: true },
            { field: 'browser', caption: 'Browser', size: '160px', sortable: true },
            { field: 'loggedon', caption: 'Logged on', size: '140px', sortable: true },
            { field: 'lastaccess', caption: 'Last access', size: '140px', sortable: true },
            { field: 'timeout', caption: 'Timeout (secs)', size: '100px' }
        ],
        records: [ ]
   },
   statToolbar: {
	name: 'statToolbar',
	items: [ 
            { type: 'button', id: 's1', text: 'Response', icon: 'fa-table', style: 'color: red' },
            { type: 'break' },
	    { type: 'button', id: 's2', text: 'Send size', icon: 'fa-table', style: 'color: silver' },
            { type: 'break' },
            { type: 'button', id: 's3', text: 'Receive size', icon: 'fa-table', style: 'color: silver' },
            { type: 'break' },
            { type: 'button', id: 's4', text: 'Net response', icon: 'fa-table',  style: 'color: silver' }
	]

   },
   statGrid: {
        name: 'statGrid',
	autoLoad : false,
	url: {
//            get    :  moduleName+'/stat'
            get    :  'stat'
            },
        show: {
	    toolbarInput    : false,
	    toolbar         : true,
	    footer          : true
        },
        multiSelect  : false,
        columns: [
            { field: 'c0', caption: 'Stat id', size: '100px' },
            { field: 'c1', caption: 'Count', size: '100px' },
            { field: 'c2', caption: 'Sum', size: '160px' },
            { field: 'c3', caption: 'Average', size: '140px' }
        ],
        records: [ ],
	postData: {"group": "s1"}
   },
   formStat: {
        name  : 'formStat',
        url   : 'statact',
        fields: [  ],
        actions: {
            stsaveall: function () {
		this.recid="91";
                this.save();
            },
            stloadall: function () {
		this.recid="92";
                this.save();
            },
            stclear: function () {
		this.recid="93";
                this.save();
            },
            stclearall: function () {
		this.recid="94";
                this.save();
            },
        }
   }

		
};

